"
    Copyright (c) 2012-2016 Igor Stasenko
                            Martin McClure
                            Damien Pollet
                            Camillo Bruni
                            Guido Chari
                   2016-now Jan Vrany <jan.vrany [at] fit . cvut . cz>

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the 'Software'), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.
"
"{ Package: 'jv:dragonfly/asm' }"

"{ NameSpace: Smalltalk }"

Object subclass:#AJGeneratedCode
	instanceVariableNames:'bytes labels'
	classVariableNames:''
	poolDictionaries:''
	category:'AsmJit-Core'
!

!AJGeneratedCode class methodsFor:'documentation'!

copyright
"
    Copyright (c) 2012-2016 Igor Stasenko
                            Martin McClure
                            Damien Pollet
                            Camillo Bruni
                            Guido Chari
                   2016-now Jan Vrany <jan.vrany [at] fit . cvut . cz>

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the 'Software'), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.

"
! !

!AJGeneratedCode class methodsFor:'instance creation'!

fromInstructions: instructions
    ^ self new fromInstructions: instructions
!

new
    "return an initialized instance"

    ^ self basicNew initialize.
! !

!AJGeneratedCode methodsFor:'accessing'!

bytes
    ^ bytes
!

bytes: aBytes 

    bytes := aBytes
    
!

labels: aLabels

    "turn labels into a simple name->offset pairs"
    aLabels keysAndValuesDo: [:name :lbl |
        labels at: name put: lbl paddedOffset ].
        
!

offsetAt: aLabelName
    ^ labels at: aLabelName
! !

!AJGeneratedCode methodsFor:'initialize-release'!

fromInstructions: instructions
    
    bytes := ByteArray new: 100 streamContents: [:stream|
        instructions do: [ :each |
            each extractLabels: [:name :pos | labels at: name put: pos ].
            each storeOn: stream ]].
!

initialize
    labels := Dictionary new.
    
! !

!AJGeneratedCode methodsFor:'output'!

dumpWithLabels

    "dump the native code , interspersed with labels"
    
    | offsets i str |
    
    offsets := OrderedCollection new.

    labels keysAndValuesDo: [ :name :offset |
        offsets add: (offset -> name)
    ].

    offsets := offsets sort: [:a :b | a key < b key ].
    
    str := String new writeStream.
    i := 0.
    
    offsets do: [:offset |
        i to: offset key -1 do: [:x | str nextPutAll: ((bytes at: i+1) printStringBase: 16 nDigits: 2) ; space. i:=i+1. ].
        str cr; nextPutAll: offset value; cr.
    ].

    i to: bytes size-1 do: [:x | str nextPutAll: ((bytes at: i+1) printStringBase: 16 nDigits: 2) ; space. i := i + 1] .
    ^ str contents
!

saveToFile
    self saveToFile: 'asm.bin'
!

saveToFile: fileName

    (FileStream forceNewFileNamed: fileName)  
        nextPutAll: bytes;
        close  
! !

!AJGeneratedCode methodsFor:'printing'!

printOn: aStream

    bytes notNil ifTrue: [
        aStream nextPutAll: self dumpWithLabels
        
        ]
! !

