"
    Copyright (c) 2012-2016 Igor Stasenko
                            Martin McClure
                            Damien Pollet
                            Camillo Bruni
                            Guido Chari
                   2016-now Jan Vrany <jan.vrany [at] fit . cvut . cz>

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the 'Software'), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.
"
"{ Package: 'jv:dragonfly/asm' }"

"{ NameSpace: Smalltalk }"

AJx86Assembler subclass:#AJx64Assembler
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:'AJx86Registers'
	category:'AsmJit-x86'
!

AJx64Assembler comment:'I am an assembler for the Intel x86-64 architecture.'
!

!AJx64Assembler class methodsFor:'documentation'!

copyright
"
    Copyright (c) 2012-2016 Igor Stasenko
                            Martin McClure
                            Damien Pollet
                            Camillo Bruni
                            Guido Chari
                   2016-now Jan Vrany <jan.vrany [at] fit . cvut . cz>

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the 'Software'), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.

"
! !

!AJx64Assembler methodsFor:'accessing'!

instructionDesciptions
    ^ AJx64InstructionDescription instructions
!

newInstruction
    ^ AJx64Instruction new
!

newJumpInstruction
    ^ AJx64JumpInstruction new
!

numGPRegisters
    ^ 16
!

pointerSize
    "see AJx86Assembler >> #pointerSize"
    ^ 8
! !

!AJx64Assembler methodsFor:'accessing registers'!

BPL
    ^ BPL
!

DIL
    ^ DIL
!

EIP
    "A 32bit instruction pointer register
    This register overlaps with IP, EIP, RIP"
    ^ EIP
!

IP
    "A 16bit instruction pointer register
    This register overlaps with IP, EIP, RIP"
    ^ IP
!

R10
    "A 64bit general purpose register
    This register overlaps with R10B, R10W, R10D, R10"
    ^ R10
!

R10B
    "A 8bit general purpose register
    This register overlaps with R10B, R10W, R10D, R10"
    ^ R10B
!

R10D
    "A 32bit general purpose register
    This register overlaps with R10B, R10W, R10D, R10"
    ^ R10D
!

R10W
    "A 16bit general purpose register
    This register overlaps with R10B, R10W, R10D, R10"
    ^ R10W
!

R11
    "A 64bit general purpose register
    This register overlaps with R11B, R11W, R11D, R11"
    ^ R11
!

R11B
    "A 8bit general purpose register
    This register overlaps with R11B, R11W, R11D, R11"
    ^ R11B
!

R11D
    "A 32bit general purpose register
    This register overlaps with R11B, R11W, R11D, R11"
    ^ R11D
!

R11W
    "A 16bit general purpose register
    This register overlaps with R11B, R11W, R11D, R11"
    ^ R11W
!

R12
    "A 64bit general purpose register
    This register overlaps with R12B, R12W, R12D, R12"
    ^ R12
!

R12B
    "A 8bit general purpose register
    This register overlaps with R12B, R12W, R12D, R12"
    ^ R12B
!

R12D
    "A 32bit general purpose register
    This register overlaps with R12B, R12W, R12D, R12"
    ^ R12D
!

R12W
    "A 16bit general purpose register
    This register overlaps with R12B, R12W, R12D, R12"
    ^ R12W
!

R13
    "A 64bit general purpose register
    This register overlaps with R13B, R13W, R13D, R13"
    ^ R13
!

R13B
    "A 8bit general purpose register
    This register overlaps with R13B, R13W, R13D, R13"
    ^ R13B
!

R13D
    "A 32bit general purpose register
    This register overlaps with R13B, R13W, R13D, R13"
    ^ R13D
!

R13W
    "A 16bit general purpose register
    This register overlaps with R13B, R13W, R13D, R13"
    ^ R13W
!

R14
    "A 64bit general purpose register
    This register overlaps with R14B, R14W, R14D, R14"
    ^ R14
!

R14B
    "A 8bit general purpose register
    This register overlaps with R14B, R14W, R14D, R14"
    ^ R14B
!

R14D
    "A 32bit general purpose register
    This register overlaps with R14B, R14W, R14D, R14"
    ^ R14D
!

R14W
    "A 16bit general purpose register
    This register overlaps with R14B, R14W, R14D, R14"
    ^ R14W
!

R15
    "A 64bit general purpose register
    This register overlaps with R15B, R15W, R15D, R15"
    ^ R15
!

R15B
    "A 8bit general purpose register
    This register overlaps with R15B, R15W, R15D, R15"
    ^ R15B
!

R15D
    "A 32bit general purpose register
    This register overlaps with R15B, R15W, R15D, R15"
    ^ R15D
!

R15W
    "A 16bit general purpose register
    This register overlaps with R15B, R15W, R15D, R15"
    ^ R15W
!

R8
    "A 64bit general purpose register
    This register overlaps with R8B, R8W, R8D, R8"
    ^ R8
!

R8B
    "A 8bit general purpose register
    This register overlaps with R8B, R8W, R8D, R8"
    ^ R8B
!

R8D
    "A 32bit general purpose register
    This register overlaps with R8B, R8W, R8D, R8"
    ^ R8D
!

R8W
    "A 16bit general purpose register
    This register overlaps with R8B, R8W, R8D, R8"
    ^ R8W
!

R9
    "A 64bit general purpose register
    This register overlaps with R9B, R9W, R9D, R9"
    ^ R9
!

R9B
    "A 8bit general purpose register
    This register overlaps with R9B, R9W, R9D, R9"
    ^ R9B
!

R9D
    "A 32bit general purpose register
    This register overlaps with R9B, R9W, R9D, R9"
    ^ R9D
!

R9W
    "A 16bit general purpose register
    This register overlaps with R9B, R9W, R9D, R9"
    ^ R9W
!

RAX
    "A 64bit general purpose register
    This register overlaps with AL, AX, EAX, RAX"
    ^ RAX
!

RBP
    "A 64bit general purpose register
    This register overlaps with CH, CX, ECX, RCX"
    ^ RBP
!

RBX
    "A 64bit general purpose register
    This register overlaps with BL, BX, EBX, RBX"
    ^ RBX
!

RCX
    "A 64bit general purpose register
    This register overlaps with CL, CX, ECX, RCX"
    ^ RCX
!

RDI
    "A 64bit general purpose register
    This register overlaps with BH, BX, EBX, RBX"
    ^ RDI
!

RDX
    "A 64bit general purpose register
    This register overlaps with DL, DX, EDX, RDX"
    ^ RDX
!

RIP
    "A 64bit instruction pointer register
    This register overlaps with IP, EIP, RIP"
    ^ RIP
!

RSI
    "A 64bit general purpose register
    This register overlaps with DH, DX, EDX, RDX"
    ^ RSI
!

RSP
    "A 64bit general purpose register
    This register overlaps with AH, AX, EAX, RAX"
    ^ RSP
!

SIL
    ^ SIL
!

SPL
    ^ SPL
!

XMM10
    "An SSE register"
    ^ XMM10
!

XMM11
    "An SSE register"
    ^ XMM11
!

XMM12
    "An SSE register"
    ^ XMM12
!

XMM13
    "An SSE register"
    ^ XMM13
!

XMM14
    "An SSE register"
    ^ XMM14
!

XMM15
    "An SSE register"
    ^ XMM15
!

XMM8
    "An SSE register"
    ^ XMM8
!

XMM9
    "An SSE register"
    ^ XMM9
! !

!AJx64Assembler methodsFor:'initialize-release'!

initialize
    super initialize.
    is64 := true.
! !

!AJx64Assembler methodsFor:'register'!

accumulator
    ^ RAX
!

basePointer
    ^ RBP 
!

counter
    ^ RCX
!

data
    ^ RDX
!

destinationIndex
    ^ RDI
!

instructionPointer
    ^ RIP
!

sourceIndex
    ^ RSI
!

stackPointer
    ^ RSP
! !

!AJx64Assembler methodsFor:'testing'!

is32
    ^ false
! !

